/*
 * Copyright (c) Openmind.  All rights reserved. http://www.openmindonline.it
 */
package it.openutils.configuration.dao;

import it.openutils.configuration.dataobjects.ReferenceCode;
import it.openutils.dao.hibernate.HibernateDAOImpl;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.springframework.orm.hibernate3.HibernateCallback;


/**
 * @author fcarone
 * @version $Id: ReferenceCodeDAOImpl.java 179 2007-02-01 16:35:22Z fcarone $
 */

public class ReferenceCodeDAOImpl extends HibernateDAOImpl<ReferenceCode, Long> implements ReferenceCodeDAO
{

    /**
     * {@inheritDoc}
     */
    @Override
    protected Class<ReferenceCode> getReferenceClass()
    {
        return ReferenceCode.class;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean delete(final Long key)
    {

        return (Boolean) getHibernateTemplate().execute(new HibernateCallback()
        {

            public Object doInHibernate(Session ses) throws HibernateException
            {

                ReferenceCode code = (ReferenceCode) ses.load(getReferenceClass(), key);
                ses.delete(code);
                // Hibernate doesn't automatically flush the session after delete and we don't know why
                ses.flush();
                return true;
            }
        });

    }

}
